<?php

// Load sources
$sources = MappingSource::getSources();

// Load mapping types
$mappingTypes = MappingType::getTypes();

// Load source fields
$sourceFields = MappingSourceField::getFields($model->getSourceId());
if (!is_array($sourceFields)) $sourceFields = array();

$mappingConfigFields = MappingConfigField::getFields($model->getId());

// Should we allow multiple includes?
$multipleIncludes = $model->getMapType() == 'license-multi' ? true : false;

$configFields = array();
foreach ($mappingConfigFields as $mappingConfigField) {
	$configFields[$mappingConfigField->getSourceFieldId()] = $mappingConfigField;
}

/* @var $model MappingConfig */

?>

<html>

<head>
	<style>
	h2 {
		background-image:url(/gfx/icons/folder_document.png);
		background-repeat:no-repeat;
		height:22px;
		margin:0 0 10px;
		padding-left:30px;
		padding-top:2px;
	}	
	</style>

	<script type="text/javascript">
	<!--
	var previewId = 0;
	
	function getPreview() {	
		var shown = document.getElementById('sourceFieldsSingle');
		var prev = 'preview_';
		var dataTab = 'data';
		if(shown.style.display != "block"){
			prev = 'mpreview_';
			dataTab = 'mdata';
		}
		var ele = 'span[id^='+prev+']';
		var jsonRequest = new Request.JSON({url: "<?= $controller->getURL(array(null, 'preview')) ?>/" + previewId + ".raw", onComplete: function(preview){
			// Empty all first
			$(dataTab).getElements(ele).each(function(el) { el.set('text', ''); });
			
			// Inserting data			
			preview.each(function(el, test3, test2, test){
				for(var p in el) if ($(prev + p)) $(prev + p).set('text', el[p]);
			});	
		}}).get();
	}
	
	function nextPreview() {
		var shown = document.getElementById('sourceFieldsSingle');
		var prev = 'preview_';
		var dataTab = 'data';
		if(shown.style.display != "block"){
			prev = 'mpreview_';
			dataTab = 'mdata';
		}
		previewId++;
		var ele = 'span[id^='+prev+']';
		// Empty all exisiting data..
		$(dataTab).getElements(ele).each(function(el) { el.set('text', '- Loading -'); });
		
		getPreview();
	}
		
	function previousPreview() {
		if (previewId <= 1) {
			alert('You are at the first record..');
			return;
		} 
		previewId--;
		previewId--;
		nextPreview();
	}
	
	function dd(obj) {
		var typeSel = document.getElementById('maptypeid');
		if (obj.selectedIndex + 1  != '<?= $model->getSourceId() ?>') {
			$('sourceFieldsSingle').setStyle('display', 'none');
			$('sourceFieldsMulti').setStyle('display', 'none');
		} else {
			if(typeSel.selectedIndex == 3){
				$('sourceFieldsSingle').setStyle('display', 'none');
				$('sourceFieldsMulti').setStyle('display', 'block');
			}
			else{
				$('sourceFieldsSingle').setStyle('display', 'block');
				$('sourceFieldsMulti').setStyle('display', 'none');
			}
		}
	}
	
	function verifyKeySelection(id) {

		var shown = document.getElementById('sourceFieldsSingle');

		var sinclude = "";
		if(shown.style.display == "block"){
			sinclude = 'includeBox';
		}else{
			sinclude = 'mincludeBox';
		}
		
		var box = document.getElementById(sinclude + id);
		if (box && box.checked) {
			box.checked = false;
		}
	}
	
	function verifyIncludeSelection(id) {
		var shown = document.getElementById('sourceFieldsSingle');

		var skey = "";
		if(shown.style.display == "block"){
			skey = 'keyBox';
		}else{
			skey = 'mkeyBox';
		}
		var box = document.getElementById(skey + id);
		if (box && box.checked) {
			box.checked = false;
		}
	}

	function verifyKeyAndIncludeSelection() {
		var try1 = <? echo count($sourceFields)?>;
		//alert(try1);
		if( parseInt(try1) > 0){
		var count = document.getElementById('count').value;
		var start = document.getElementById('start').value;
		var shown = document.getElementById('sourceFieldsSingle');

		//alert(count + ' - ' + start);
		
		var i = 0;
		var max = parseInt(count)+parseInt(start);
		var iflag = false;
		var kflag = false;

		var sinclude = "";
		var skey = "";

		if(shown.style.display == "block"){
			//alert("block");
			sinclude = 'includeBox';
			skey = 'keyBox';
		}else{
			//alert("none");
			sinclude = 'mincludeBox';
			skey = 'mkeyBox';
		}

		//alert(start + " - " + max);
		for(i = start; i < max; i++){
			if(!document.getElementById(sinclude + i)  || !document.getElementById(skey + i))continue;
			var ibox = document.getElementById(sinclude + i);
			var kbox = document.getElementById(skey + i);

			//alert(ibox + " - " + kbox);
			iflag = iflag || ibox.checked;
			kflag = kflag || kbox.checked;
		}

		if(!kflag || !iflag){
			if(!kflag){
				alert("At least one field should be set as key");
			}else if(!iflag){
				alert("At least one field should be included");
			}
			return false;
		}
		return true;
		}else return true;
	}

	function copySelections(){
		//copies the current selection to the table to be shown
		var count = document.getElementById('count').value;
		var start = document.getElementById('start').value;
		var shown = document.getElementById('sourceFieldsSingle');

		var sinclude = "";
		var skey = "";
		var dinclude = "";
		var dkey = "";
		if(shown.style.display == "block"){
			sinclude = 'includeBox';
			skey = 'keyBox';
			dinclude = 'mincludeBox';
			dkey = 'mkeyBox';
		}else{
			sinclude = 'mincludeBox';
			skey = 'mkeyBox';
			dinclude = 'includeBox';
			dkey = 'keyBox';
		}
			
		
		var i = 0;
		//clear selections
		for (i = start; i <= count; i++){
			document.getElementById(dinclude + i).checked = false;
			document.getElementById(dkey + i).checked = false;
		} 

		//copy the current selections
		for (i = start; i <= count; i++){
			document.getElementById(dinclude + i).checked = document.getElementById(sinclude + i).checked;
			document.getElementById(dkey + i).checked = document.getElementById(skey + i).checked;
		} 
	}

	function Refresh(id){
		var single = document.getElementById('sourceFieldsSingle');
		var multi = document.getElementById('sourceFieldsMulti');
		var showSpan = document.getElementById('shownSpan');
		if(id == 3){
			copySelections();
			single.style.display="none";
			multi.style.display="block";
			showSpan.value = "";
		}else{
			copySelections();
			single.style.display="block";
			multi.style.display="none";
			showSpan.value = "single";
		}
	}

	
	//-->
	</script>	
</head>

<body>


	<div style="margin: 10px">
	
		<h2>Mapping Config</h2>
	
		<form name="mapping" action="<?= $controller->getURL(array(null)) ?>" onsubmit="return verifyKeyAndIncludeSelection(this)" method="post">
			<fieldset>
				<legend>Editing Mapping Config</legend>
				
				<div>		
					<p style="float: left; margin-right: 10px;">
						Source:
						<select name="sourceid" id="sourceid" onchange="dd(this)">
							<option value="">Select Type</option>
							<?php foreach ($sources as $sourceEntry) { ?>
							<option value="<?= $sourceEntry->getId() ?>" <?= $model->getSourceId() == $sourceEntry->getId() ? 'selected="selected"' : '' ?>><?= $sourceEntry->getName() ?></option>
							<?php } ?>
						</select>
					</p>

					<p style="float: left; margin-right: 10px;">
						Type:
						<select name="maptypeid" id="maptypeid" onChange="Refresh(this.value)">
							<option value="">Select Type</option>
							<?php foreach ($mappingTypes as $mappingType) { ?>
							<option value="<?= $mappingType->getId() ?>" <?= $model->getMapTypeId() == $mappingType->getId() || $_POST['mapType'] == $mappingType->getId() ? 'selected="selected"' : '' ?>><?= $mappingType->getName() ?></option>
							<?php } ?>
						</select>
					</p>
					
					<p style="float: left; margin-right: 10px;">					
						Label: <input type="text" name="file" id="file" value="<?= $model->getFile() ?>">
					</p>
					
					
					<p style="float: left; margin-right: 10px;">					
						Use History:
							<input type="radio" name="historic" id="historic" value="1" <?= $model->getHistoric() ? 'checked="checked"' : '' ?>> Yes
							<input type="radio" name="historic" id="historic" value="0" <?= !$model->getHistoric() ? 'checked="checked"' : '' ?>> No
					</p>
											
					<div class="clearer"></div>
					
				</div>
			</fieldset>
		
		
			<span id="sourceFieldsSingle" style="display:<?= $multipleIncludes ? "none" : "block"?>">
			<?php if (count($sourceFields) > 0) { ?>			
				<table class="list">
				
				<thead>
					<tr>
						<th class="title">
							Source Field
							<a href="<?= $controller->getURL(array('source', $model->getSourceId(), 'edit')) ?>">Edit Source</a>	
						</th>
						<th class="preview">
							Preview
							(
							<a href="javascript:previousPreview()">Previous</a> | <a href="javascript:nextPreview()">Next</a>
							)	
						</th>
						<th class="edit">Key(s)</th>
						<th class="edit">Include</th>
					</tr>
				</thead>
					
				<tbody id="data">
					<?php
						$counter = 0;
						foreach ($sourceFields as $sourceField) {
							$counter++;
							$oddEven = !isset($oddEven) || $oddEven == 'odd' ? 'even' : 'odd';
					?>
					<tr class="<?= $oddEven ?>">
						<td class="title"><?= $sourceField->getName() ?></td>
						<td class="preview"><span id="preview_<?= $sourceField->getName() ?>">- Not loaded -</span></td>
						<td class="edit">
							<input type="checkbox" name="sourceFieldMapId[]" id="keyBox<?= $sourceField->getId() ?>" value="<?= $sourceField->getId() ?>" onclick="verifyKeySelection(<?= $sourceField->getId() ?>)" onkeyup="verifyKeySelection(<?= $sourceField->getId() ?>)" <?=  isset($configFields[$sourceField->getId()]) && !$configFields[$sourceField->getId()]->isFieldType() ? 'checked="checked"' : '' ?> /></td>						
						<td class="edit">
							<input type="radio" id="includeBox<?= $sourceField->getId() ?>" name="include[]" value="<?= $sourceField->getId() ?>" onclick="verifyIncludeSelection(<?= $sourceField->getId() ?>)" <?= isset($configFields[$sourceField->getId()]) && $configFields[$sourceField->getId()]->isFieldType() ? 'checked="checked"' : '' ?> />
						</td>
					</tr>		
					<?php }
					?>			
				</tbody>
				
				</table>
				<?php } ?>
			</span>
			
			
			<span id="sourceFieldsMulti" style="display:<?= $multipleIncludes ? "block" : "none"?>">
			<?php if (count($sourceFields) > 0) { ?>	
			<table id="multi" class="list" >
				
				<thead>
					<tr>
						<th class="title">
							Source Field
							<a href="<?= $controller->getURL(array('source', $model->getSourceId(), 'edit')) ?>">Edit Source</a>	
						</th>
						<th class="preview">
							Preview
							(
							<a href="javascript:previousPreview()">Previous</a> | <a href="javascript:nextPreview()">Next</a>
							)	
						</th>
						<th class="edit">Key(s)</th>
						<th class="edit">Include</th>
					</tr>
				</thead>
					
				<tbody id="mdata">
					<?php
						$counter = 0;
						foreach ($sourceFields as $sourceField) {
							$counter++;
							$oddEven = !isset($oddEven) || $oddEven == 'odd' ? 'even' : 'odd';
					?>
					<tr class="<?= $oddEven ?>">
						<td class="title"><?= $sourceField->getName() ?></td>
						<td class="preview"><span id="mpreview_<?= $sourceField->getName() ?>">- Not loaded -</span></td>
						<td class="edit">
							<input type="checkbox" name="msourceFieldMapId[]" id="mkeyBox<?= $sourceField->getId() ?>" value="<?= $sourceField->getId() ?>" onclick="verifyKeySelection(<?= $sourceField->getId() ?>)" onkeyup="verifyKeySelection(<?= $sourceField->getId() ?>)" <?=  isset($configFields[$sourceField->getId()]) && !$configFields[$sourceField->getId()]->isFieldType() ? 'checked="checked"' : '' ?> /></td>						
						<td class="edit">
							<input type="checkbox" id="mincludeBox<?= $sourceField->getId() ?>" onclick="verifyIncludeSelection(<?= $sourceField->getId() ?>)" name="minclude[]" value="<?= $sourceField->getId() ?>" <?= isset($configFields[$sourceField->getId()]) && $configFields[$sourceField->getId()]->isFieldType() ? 'checked="checked"' : '' ?> />
						</td>
					</tr>		
					<?php }

					?>			
				</tbody>
				
				</table>
				<?php } ?>
			</span>
			
				<input type="hidden" name="start" id="start" value="<?= $sourceFields  ? $sourceFields[0]->getId() : "" ?>" />
				<input type="hidden" name="shownSpan" id="shownSpan" value="<?= $multipleIncludes  ? "default" : "single" ?>" />
				<input type="hidden" name="count" id="count" value="<?= $counter ?>" />		
			<input type="submit" value="Submit"  />
			
		</form>
	
	</div>
	
</body>
</html>
